// TreeBar.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "soprano_m.h"
#include "MainFrm.h"
#include "TreeBar.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTreeBar

CTreeBar::CTreeBar()
:m_nViewMode(0)
{
	
}

CTreeBar::~CTreeBar()
{
	delete m_pData;
}


BEGIN_MESSAGE_MAP(CTreeBar, CMRCSizeDialogBar)
	//{{AFX_MSG_MAP(CTreeBar)
	ON_NOTIFY(TVN_SELCHANGED,IDC_INFO_TREE, OnSelchanged)
	ON_NOTIFY(TVN_KEYDOWN, IDC_INFO_TREE,OnKeydown)
	ON_NOTIFY(NM_DBLCLK,IDC_INFO_TREE, OnDblclk)
	ON_NOTIFY(NM_RCLICK,IDC_INFO_TREE, OnRButton)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeBar bZ[W nh

/*----------------------------------------------------------------------------*/
//  T  vF  c[Rg[ւ̃|C^擾
//    F  void
//  ߂lF  CTreeCtrl*
//    lF  CTreeView::GetTreeCtrl()̃}l
/*----------------------------------------------------------------------------*/
CTreeCtrl* CTreeBar::GetTreeCtrl()
{
    CTreeCtrl *pTree = (CTreeCtrl*)GetDlgItem(IDC_INFO_TREE);
	return pTree;
}

/*----------------------------------------------------------------------------*/
//  T  vF  w肳ꂽԂŃc[ĕ`悷
//    F  `惂[h
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeBar::RefreshTree(int nMode)
{
	m_nViewMode = nMode;

	GetData()->ClearItemList();
	GetTreeCtrl()->DeleteAllItems();

	CMoeFile *pFile;
	
	CTreeCtrl *pTree = GetTreeCtrl();
	HTREEITEM hRoot = pTree ->GetRootItem();

	CWnd::LockWindowUpdate();	// ĕ`~()

	for(int i = 0 ; i < GetData() ->GetMoeMax();i++)
	{
		pFile = GetData() ->GetMoeFile(i);
		
		if(pFile != NULL)
		{
			RefreshTree(nMode,pFile,hRoot);
		}
	}

	CWnd::UnlockWindowUpdate(); // ĕ`

	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[`悷
//    F  STreẽ|C^
//  ߂lF  void
//    lF  }`XbhŃc[́E`悷
/*----------------------------------------------------------------------------*/
UINT CTreeBar::RefreshTree(LPVOID pParam)
{
	STree *p_stTree = (STree*)pParam;
	CTreeBar *pView = (CTreeBar*)p_stTree->pView;
	
	p_stTree->pMain->SetStatusText(_T("͒..."));
	p_stTree->pMoe->Clear();
	p_stTree->pMoe->SetUrl(p_stTree->cUrl,MOE_FULL);
	pView->RefreshTree(p_stTree->nMode);
	p_stTree->pMain->SetStatusText(_T("Done"));
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[ɃACeǉ
//    F  nRootType = `̎d, pFile = ǉt@C, hRoot = [g̃nh
//  ߂lF  0
//    lF  ۂɃACeǉ
/*----------------------------------------------------------------------------*/
int CTreeBar::RefreshTree(int nRootType, CMoeFile *pFile, HTREEITEM hRoot)
{
	if(pFile == NULL) {return -1;}

	CTreeCtrl *pTree = GetTreeCtrl();

	// w肳ꂽc[݂邩`FbN
	CString cBuf,cDate;

	switch(nRootType)
	{
	case V_DATE:
	case V_DOUBLE:
		CTime *pTime;
		pTime = pFile->GetTime();

		//cBuf = GetData()->GetDate();
		cBuf = pTime->Format(GetData()->GetData()->GetDateFormat());
		// t
		// pFile ->GetDate(cBuf);
		break;

	case VD_SOURCE:
		pFile ->GetDate(cDate);
		// 킴ƁAu[NȂ
	case V_SOURCE:
		// \[X
		pFile ->GetSource(cBuf);
		break;
	}

	HTREEITEM hTreeTitle;
	TVINSERTSTRUCT stItem;

	// `FbN
	int i = 0;
	if(nRootType == VD_SOURCE)
	{
		i = GetData()->FindTreeItem(cDate +cBuf);
	}else{
		i = GetData()->FindTreeItem(cBuf);
	}

	if(i == -1)
	{
		// ݂ȂȂA[gɒǉ
		stItem.hParent = hRoot;
		stItem.hInsertAfter = TVI_ROOT;
		stItem.item.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_IMAGE;
		stItem.item.pszText = (LPSTR)(LPCTSTR)cBuf;
		stItem.item.iImage = 0;
		stItem.item.cChildren = 1;
		
		// ACeǉB
		hTreeTitle = pTree ->InsertItem(&stItem);

		if(nRootType == VD_SOURCE)
		{
			cBuf = cDate +cBuf;
		}
		
		GetData()->SetTreeItem(cBuf,hTreeTitle);
		
	}else{

		if(nRootType == VD_SOURCE)
		{
			cBuf = cDate +cBuf;
		}

		hTreeTitle = GetData()->GetTreeItem(cBuf);
	}

	// ^Cg擾
	CString cTitle;
	if(pFile ->GetTitle(cTitle) != 0)
	{
		return -1;
	}

	if(nRootType != V_DOUBLE)
	{
		stItem.hParent = hTreeTitle;
		stItem.hInsertAfter = TVI_LAST;
		stItem.item.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_IMAGE |  TVIF_SELECTEDIMAGE;
		stItem.item.pszText = (LPSTR)(LPCTSTR)cTitle;
		stItem.item.cChildren = 0;
		stItem.item.iImage = 2;
		stItem.item.iSelectedImage =3;
		pTree ->InsertItem(&stItem);
		return 0;
	}else{
		RefreshTree(VD_SOURCE,pFile,hTreeTitle);
		return 0;
	}
}
/*----------------------------------------------------------------------------*/
//  T  vF  \zꂽɌĂяo
//    F  void
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeBar::Init()
{
	m_pData = new CTreeData;

	// c[Rg[̏
	BOOL b = m_cImageList.Create(16,16,ILC_COLOR8|ILC_MASK,0,1);
	if(b)
	{
		CBitmap cBmp;
		b=cBmp.LoadBitmap(IDB_ICONLIST);
		if (b) {
			m_cImageList.Add(&cBmp,RGB(0xff, 0xff, 0xff));
		}
		GetTreeCtrl()->SetImageList(&m_cImageList,TVSIL_NORMAL);
	}
	
//	m_pMoe = ((CMainFrame*)AfxGetMainWnd())->GetMoe();
//	m_pData = ((CMainFrame*)AfxGetMainWnd())->GetData();

	m_stTree.pView = this;
	m_stTree.cUrl = m_cURL;
	m_stTree.pMain = (CMainFrame*)::AfxGetMainWnd();
	m_stTree.nMode = m_nViewMode;
	m_stTree.pMoe = GetData()->GetMoe();
	::AfxBeginThread(CTreeBar::RefreshTree,&m_stTree);
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  URLݒ肷
//    F  lpURL = URL
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeBar::SetURL(LPCTSTR lpURL)
{
	m_cURL = lpURL;
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  `̍ۂ̕\Ԃݒ肷
//    F  \[h
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeBar::SetTreeMode(int nMode)
{
	m_nViewMode = nMode;
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  NMHDRt@C^Cg擾
//    F  pNMHDR = NMHDR\̂ւ̃|C^ , bShif = VtgL[̏
//  ߂lF  void
//    lF  void
/*----------------------------------------------------------------------------*/
void CTreeBar::OpenUrl(NMHDR *pNMHDR, BOOL bShift)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// c[Rg[ւ̃|C^l
	CTreeCtrl* pTree=(CTreeCtrl*)FromHandle(pNMHDR->hwndFrom);

	// Iꂽڂ𓾂
	HTREEITEM hItem = pTree->GetSelectedItem();

	if(hItem)
	{
		CString cTitle = pTree ->GetItemText(hItem);

		if(bShift != 0)
		{
			OpenUrl(cTitle,NEW_OPEN);
		}else{
			OpenUrl(cTitle,NONE_OPEN);
		}
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  ^CgURL擾J
//    F  lpTitle = ^Cg , nMode = VEChEJ
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeBar::OpenUrl(LPCTSTR lpTitle, int nMode)
{
//	if(GetData()->GetMoe() == NULL){return -1;}
	


	// URL擾J
	CString cURL;
	cURL = GetData()->GetURL(lpTitle);
	
	if(cURL != _T(""))
	{
		if(nMode == NEW_OPEN)
		{
			// VEChEJ
			((CSoprano_mApp*)AfxGetApp())->OnFileNew();
		}
		
		CMDIFrameWnd *pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
		CMDIChildWnd *pChild = (CMDIChildWnd*)pFrame->GetActiveFrame();
		CSoprano_mView *pView = (CSoprano_mView*)pChild->GetActiveView();

		if(pView == NULL)
		{
			((CSoprano_mApp*)AfxGetApp())->OnFileNew();
			pChild = (CMDIChildWnd*)pFrame->GetActiveFrame();
			pView = (CSoprano_mView*)pChild->GetActiveView();
		}

		// J
		pView->SetTitle(lpTitle);
		pView->Navigate2(cURL,NULL,NULL);
	
		return 0;
	}else{
		return -1;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  bZ[Wnh֐
//    F  MSDNQ
//  ߂lF  MSDNQ
//    lF  ݒɂẮAURLJ
/*----------------------------------------------------------------------------*/
void CTreeBar::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// ςȂshift̏Ԃ擾Ƃ
	BOOL bShift = (GetKeyState(VK_SHIFT) & 0x8000); 

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// uIvŊJݒ肩`FbN
	if(GetData()->GetData()->GetTreeOpenMode() == SELECTED)
	{
		OpenUrl(pNMHDR,bShift);
	}
	*pResult = 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  bZ[Wnh֐
//    F  MSDNQ
//  ߂lF  MSDNQ
//    lF  ݒɂẮAURLJ
/*----------------------------------------------------------------------------*/
void CTreeBar::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult)
{
	// ςȂshift̏Ԃ擾Ƃ
 	BOOL bShift = (GetKeyState(VK_SHIFT) & 0x8000); 
 
 	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
 
 	// uIvŊJݒ肩`FbN
	if(GetData()->GetData()->GetTreeOpenMode() == DCLICK)
 	{
 		OpenUrl(pNMHDR,bShift);
	}
 	*pResult = 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[ŃL[ꂽBbZ[Wnh֐
//    F  MSDNQ
//  ߂lF  MSDNQ
//    lF  ݒɂẮAURLJ
/*----------------------------------------------------------------------------*/
void CTreeBar::OnKeydown(NMHDR* pNMHDR, LRESULT* pResult)
{
	// ςȂshift̏Ԃ擾Ƃ
	BOOL bShift = (GetKeyState(VK_SHIFT) & 0x8000); 

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	NMTVKEYDOWN* pKey = (NMTVKEYDOWN*)pNMHDR;

	if(pKey->wVKey != VK_SHIFT)
	{
		OpenUrl(pNMHDR,bShift);
	}
	
	*pResult = 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[̕\ԂԂ
//    F  void
//  ߂lF  萔
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeBar::GetTreeMode()
{
	return m_nViewMode;
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[ĕ`悷
//    F  void
//  ߂lF  0
//    lF  t@C̃_E[h蒼
/*----------------------------------------------------------------------------*/
int CTreeBar::RefreshTree()
{
	// 
	GetData()->SetTime(0,0);
	GetData()->MoeClear();

	m_stTree.pView = this;
	m_stTree.cUrl = GetData()->GetData()->GetMoeUrl();
	m_stTree.nMode = m_nViewMode;
	m_stTree.pMoe = GetData()->GetMoe();
	::AfxBeginThread(CTreeBar::RefreshTree,&m_stTree);
	return 0;	
}

CTreeData* CTreeBar::GetData()
{
	return m_pData;
}

void CTreeBar::ViewTimeDlg()
{
	m_stTimeLog.pData = GetData();
	m_stTimeLog.pBar = this;
	m_stTimeLog.pMain = (CMainFrame*)::AfxGetMainWnd();
	::AfxBeginThread(CTreeBar::ViewLog,&m_stTimeLog);
	/*(cDlg.DoModal() == IDOK)
	{
		GetData()->SetTime(cDlg.m_cFromTime,cDlg.m_cToTime);
		RefreshTree(m_nViewMode);
	}*/
}

/*----------------------------------------------------------------------------*/
//  T  vF  O\Xbh
//    F  STimeLogւ̃|C^
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
UINT CTreeBar::ViewLog(LPVOID pParam)
{
	STimeLog* pLog = (STimeLog*)pParam;
	CTimeDlg cDlg;
	CTime cTo,cFrom;

	pLog->pData->GetTime(cFrom,cTo);

	cDlg.m_cFromTime = cFrom;
	cDlg.m_cToTime = cTo;

	if(cDlg.DoModal() == IDOK)
	{
		pLog->pMain->SetStatusText(_T("͒..."));

		if(cDlg.m_nMode != 0)
		{
			pLog->pData->ClearItemList();
			pLog->pData->SetTime(cDlg.m_cFromTime,cDlg.m_cToTime);
		}else{
			pLog->pData->AddTime(cDlg.m_cFromTime,cDlg.m_cToTime);
		}

		pLog->pBar->RefreshTree(pLog->pBar->GetTreeMode());
		pLog->pMain->SetStatusText(_T(""));
	}
	return 0;
}

void CTreeBar::OnRButton(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	*pResult = 0;
}

void CTreeBar::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	//CMRCSizeDialogBar::OnRButtonDown(nFlags, point);
}
