// TreeData.cpp: CTreeData NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "soprano_m.h"
#include "TreeData.h"
#include "MainFrm.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CTreeData::CTreeData()
{
	m_pMoe = ((CMainFrame*)AfxGetMainWnd())->GetMoe();
	m_pData = ((CMainFrame*)AfxGetMainWnd())->GetData();
	m_cFromTime = 0;
	m_cToTime = 0;
}

CTreeData::~CTreeData()
{

}

/*----------------------------------------------------------------------------*/
//  T  vF  CMoeTopւ̃|C^擾
//    F  void
//  ߂lF  CMoeTop*
//    lF  ȂׂgȂ
/*----------------------------------------------------------------------------*/
CMoeTop* CTreeData::GetMoe()
{
	return m_pMoe;
}

/*----------------------------------------------------------------------------*/
//  T  vF  CSopranoIniւ̃|C^擾
//    F  void
//  ߂lF  CSopranoIni*
//    lF  ݒ擾̂Ɏg
/*----------------------------------------------------------------------------*/
CSopranoIni* CTreeData::GetData()
{
	return m_pData;
}

/*----------------------------------------------------------------------------*/
//  T  vF  ACeXg
//    F  void
//  ߂lF  0
//    lF  
/*----------------------------------------------------------------------------*/
int CTreeData::ClearItemList()
{
	m_mTreeItem.clear();
	return 0;
}

/*----------------------------------------------------------------------------*/
//  T  vF  CMoeTop̊ǗĂCMoeFile̐擾
//    F  void
//  ߂lF  ǗĂ鐔
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeData::GetMoeMax()
{
	return m_pMoe->GetMaxIndex();
}

/*----------------------------------------------------------------------------*/
//  T  vF  CMoeFile*ւ̃|C^擾
//    F  CfbNX
//  ߂lF  CMoeFile*
//    lF  void
/*----------------------------------------------------------------------------*/
CMoeFile* CTreeData::GetMoeFile(int nIndex)
{
	CMoeFile *pFile;
	pFile = m_pMoe->GetFileInfo(nIndex);

	if(m_cToTime != 0 || m_cFromTime != 0)
	{
		CTime cTime;
		cTime = *pFile->GetTime();

		if(cTime == 0)
		{
			return pFile;
		}
		// Ԑݒ肪ꍇ
		if(m_cFromTime < cTime && cTime < m_cToTime)
		{
			return pFile;
		}else{
			return NULL;
		}
	}else{
		return pFile;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[ACe
//    F  L[[h
//  ߂lF  0 = , -1 = Ȃ
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeData::FindTreeItem(CString cKey)
{
	if(m_mTreeItem.find(cKey) == m_mTreeItem.end())
	{
		return -1;
	}else{
		return 0;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  c[ACeǉ
//    F  cTitle = ^Cg, hItem = c[̃nh
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeData::SetTreeItem(CString cTitle, HTREEITEM hItem)
{
	m_mTreeItem[cTitle] = hItem;
	return 0;
}


/*----------------------------------------------------------------------------*/
//  T  vF  c[ACẽnh擾
//    F  cKey = L[[h
//  ߂lF  HTREEITEM
//    lF  void
/*----------------------------------------------------------------------------*/
HTREEITEM CTreeData::GetTreeItem(CString cKey)
{
	return m_mTreeItem[cKey];
}

/*----------------------------------------------------------------------------*/
//  T  vF  tݒ肷
//    F  Jn / I
//  ߂lF  0
//    lF  void
/*----------------------------------------------------------------------------*/
int CTreeData::SetTime(CTime cFrom, CTime cTo)
{
	m_cFromTime = cFrom;
	m_cToTime = cTo;

	if(cTo == 0 && cFrom == 0)
	{
		return 0;
	}

	int nFromMonth,nToMonth;

	nFromMonth = m_cFromTime.GetMonth();
	nToMonth   = m_cToTime.GetMonth();

	int nFromYear,nToYear;
	nFromYear = m_cFromTime.GetYear();
	nToYear = m_cToTime.GetYear();

	if(cFrom > cTo)
	{
		return -1;
	}

	// ߂
	int nSpan;
	nSpan = (nToYear*12 + nToMonth) - (nFromYear*12 + nFromMonth)+1;

	int nMonth,nYear;
	nYear = nFromYear;
	for(int i= 0 ; i < nSpan;i++)
	{
		nMonth = nFromMonth +i;
		
		if(nMonth > 13)
		{
			nMonth = nMonth -12;
			nYear ++;
		}

		AnalysisLog(nYear,nMonth);
	}


	return 0;
}

/*-----------------m-----------------------------------------------------------*/
//  T  vF  ߋỎ
//    F  
//  ߂lF  
//    lF  
/*----------------------------------------------------------------------------*/
int CTreeData::AnalysisLog(int nYear, int nMonth)
{
	nYear = nYear - 2000;	// 񌅂ŕ\悤ɂB(Ƃ2100N킯Ȃ)

	CString cYear;
	if(nYear < 10)
	{
		cYear.Format("0%u",nYear);
	}else{
		cYear.Format("%u",nYear);
	}

	CString cMonth;
	if(nMonth < 10)
	{
		cMonth.Format("0%u",nMonth);
	}else{
		cMonth.Format("%u",nMonth);
	}

	CString cUrl;
	cUrl = m_pData->GetMoeUrl() + _T("sa")+cYear + cMonth + _T(".html");
	return m_pMoe->SetUrl(cUrl);
}

/*----------------------------------------------------------------------------*/
//  T  vF  ^CgURL擾
//    F  lpTitle = ^Cg
//  ߂lF  URL
//    lF  void
/*----------------------------------------------------------------------------*/
CString CTreeData::GetURL(LPCTSTR lpTitle)
{
	// CfbNX擾
	int nIndex =m_pMoe ->GetFileIndex(lpTitle);

	if(nIndex < 0){ return _T("");}

	// āAt@C̏擾
	CMoeFile* pFile = m_pMoe->GetFileInfo(nIndex);

	CString cBuf;
	if(pFile->GetUrl(cBuf) == 0)
	{
		return cBuf;
	}else{
		return _T("");
	}
}

void CTreeData::MoeClear()
{
	m_pMoe->Clear();
}

int CTreeData::GetTime(CTime &rFrom, CTime &rTo)
{
	rFrom = m_cFromTime;
	rTo   = m_cToTime;
	return 0;
}

int CTreeData::AddTime(CTime cFrom, CTime cTo)
{
	if(cFrom > m_cFromTime)
	{
		cFrom = m_cFromTime;
	}

	if(cTo < m_cToTime)
	{
		cTo = m_cToTime;
	}
	return SetTime(cFrom, cTo);
}
